class UsersController < ApplicationController
  before_action :set_user, only: %i[ destroy edit show update ]

  def index
    @title = "All users"
    @users = User.all
  end

  def edit
    @title = "My settings"
  end

  def update
    if @user.update(user_params)
      redirect_to contests_path
    else
      render :edit, status: :unprocessable_entity
    end
  end

  def show
    redirect_to edit_user_path(@user)
  end

  def new
    @title = "New user"
    @user = User.new()
  end

  def create
    @user = User.new(user_params)
    if @user.save
      redirect_to users_path
    else
      @title = "New user"
      render :new, status: :unprocessable_entity
    end
  end

  def destroy
  end

  private

  def set_user
    @user = User.find(params[:id])
  end

  def user_params
    params.expect(user: [ :username, :email_address, :password ])
  end
end
